module Tokipona
  # Splits text into tokens (words and punctuations).
  #
  # @example
  #   Tokipona::Tokenizer.tokenize("mi pona anu seme?")
  #   # => ["mi", "pona", "anu", "seme", "?"]
  class Tokenizer
    # @param text [String]
    #
    # @return [Array<String>]
    def self.tokenize(text)
      new(text).tokenize
    end

    def initialize(text)
      @text = text
    end

    def tokenize
      @text.scan(/\w+|[^\s]/)
    end
  end
end
